﻿using System;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadPropertyGridCustomItemElement
{
    class CustomPropertyGridItemElement : PropertyGridItemElement
    {
        RadButtonElement button;

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.button = new RadButtonElement();
            this.button.Text = ". . .";
            this.button.Click += new EventHandler(button_Click);
            this.button.StretchHorizontally = false;
            this.button.Margin = new Padding(0, 3, 1, 3);
            this.button.Alignment = System.Drawing.ContentAlignment.MiddleRight;
            this.button.MouseDown += button_MouseDown;
            this.button.MouseUp += button_MouseUp;
            this.ValueElement.Children.Add(this.button);
        }

        private void button_MouseUp(object sender, MouseEventArgs e)
        {
            this.Data.Tag = null;
        }

        private void button_MouseDown(object sender, MouseEventArgs e)
        {
            this.Data.Tag = "CancelEdit";
        }

        protected override void DisposeManagedResources()
        {
            this.button.Click -= button_Click;
            base.DisposeManagedResources();
        }

        private void button_Click(object sender, EventArgs e)
        {
            Form2 dialog = new Form2();
            dialog.TextBoxText = ((PropertyGridItem)this.Data).Value.ToString();

            DialogResult result = dialog.ShowDialog();

            if (result == DialogResult.OK)
            {
                ((PropertyGridItem)this.Data).Value = dialog.TextBoxText;
            }
        }

        //public override void AddEditor(IInputEditor editor)
        //{ }

        //public override void RemoveEditor(IInputEditor editor)
        //{ }

        public override bool IsCompatible(PropertyGridItemBase data, object context)
        {
            PropertyGridItem item = data as PropertyGridItem;
            if (item != null && item.PropertyType == typeof(string) && item.Name == "SpecialText")
            {
                return true;
            }
            return false;
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(PropertyGridItemElement);
            }
        }
    }
}